#include <iostream>
#include <string>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <pthread.h>
#include <thread>//使用c++11的多线程
#include <sys/stat.h>
#include <sys/wait.h>
#include "urlcode.h"

using namespace std;

class WebServer
{
    public:
        WebServer();
        ~WebServer();
        int ServerInit(u_short port);
        int ServerError(string str);
        int ServerAccept();
        int ServerClose();
        int ServerRequest(int cli_fd);
        int ServerCatHttpPage(int cli_fd,char *path,int filesize);
        int ServerGetFunction(int cli_fd,char *path,char *args);
        int ServerPostFunction(int cli_fd,char *path,char *args);
        int ServerExecuteCGI(int cli_fd,char *path,char *args);
        int get_line(int cli_fd,char * buf,int size);//来自tinyhttpd
        int get_filetype(char *type,char *path);

        int Page_Headers(int cli_fd,char *type,int filesize);
        int Page_Cat(int cli_fd,FILE * fp);
        int Page_200(int cli_fd);
        int Page_400(int cli_fd);
        int Page_404(int cli_fd);
        int Page_500(int cli_fd);
        int Page_501(int cli_fd);
    private:
        int httpd;
};

int WebServer::ServerRequest(int cli_fd)
{
    char buf[1024];
    int size=1024;
    int i,j;
    char method[255];//用于保存请求方式
    char url[512];
    char path[1024];
    char args[1024];
    struct stat st;
    int cgi;//cgi 为0 表示get普通方法 1表示get带参方法  2表示post方法
    pid_t pid;
    memset(buf,0,sizeof(buf));
    cgi=0;
    //获取第一行请求信息 一般格式为: GET / HTTP/1.1
    //                               POST / HTTP/1.1
    size=get_line(cli_fd,buf,sizeof(buf));
    //cout<<"\t\t"<<buf<<endl;
    i=0,j=0;
    //截取第一个单词
    while(!isspace(buf[j]) && (i<sizeof(method)-1))
    {
        method[i]=buf[j];
        i++;j++;
    }
    method[i]='\0';
    //取第一个与第二个单词之间的空格
    while(isspace(buf[j]) && (j<sizeof(buf)))
        j++;

    if(strcasecmp(method,"GET") && strcasecmp(method,"POST"))
    {
        Page_501(cli_fd);
        return -1;
    }
    
    if(strcasecmp(method,"GET")==0)
    {
    //    cout<<"此次请求的方式是GET方法"<<endl;
        cgi=0;
    }
    else if(strcasecmp(method,"POST")==0)
    {
    //    cout<<"此次请求的方式是POST方法"<<endl;
        cgi=2;
    }

    //截取第二个单词
    i=0;
    int flag=0;
    while(!isspace(buf[j]) && (i<sizeof(url)-1) && (j<sizeof(buf)))
    {
        if(buf[j]=='?')
        {
            flag=1;
            j++;
            url[i]='\0';
            i=0;
            cgi=(cgi==0?1:2);
            continue;
        }
        if(flag==0)
        {
            url[i]=buf[j];
            i++;j++;
        }
        else if(flag==1)
        {
            args[i]=buf[j];
            i++;j++;
        }
    }
    if(flag==0)
        url[i]='\0';
    else
        args[i]='\0';

    sprintf(path,"www%s",url);//这个是web服务器的主目录，这个以后可以处理成读取配置文件，这里就先写固定的www目录
    if(path[strlen(path)-1]=='/')
        strcat(path,"index.html");//同上

    //cout<<"============>此次请求的地址为:"<<path<<":"<<args<<endl;

    //根据文件名，获取该文件的文件信息。如果为-1，表示获取该文件失败
    if(stat(path,&st)==-1)
    {
        while((size>0) && strcmp("\n",buf))//去除掉多余的请求头信息
            size=get_line(cli_fd,buf,sizeof(buf));
        Page_404(cli_fd);
    }
    else
    {
        if(S_ISDIR(st.st_mode))//判断url地址，如果是个目录，那么就访问该目录的index.html
        {
            strcat(path,"/index.html");
            if(stat(path,&st)==-1)
            {
                Page_404(cli_fd);
            }
        }
        if(!S_ISDIR(st.st_mode)&&((st.st_mode & S_IXUSR) || (st.st_mode & S_IXGRP) || (st.st_mode & S_IXOTH)))//判断该url地址所对应的文件是否是可执行，并且是否有权限
        {
            //是一个cgi程序
            if(strcasecmp(method,"GET")==0)
                cgi=1;
            else if(strcasecmp(method,"POST")==0)
                cgi=2;
            else
                cgi=0;
        }
        cout<<"访问:"<<path<<endl;
        if(cgi==0)//如果cgi为0，那么就表示该url所对应的文件不是cgi程序，而是一个简单的静态页面
        {
            pid = fork();
            if(pid==0)
            {
                ServerCatHttpPage(cli_fd,path,st.st_size);
            }
        }
        else if(cgi==1)//get方法带参数
        {
            pid=fork();
            if(pid==0)
            {
                while((size>0) && strcmp("\n",buf))//去除掉多余的请求头信息
                    size=get_line(cli_fd,buf,sizeof(buf));
                ServerGetFunction(cli_fd,path,urldecode(args));
            }
        }
        else if(cgi==2)//post方法
        {
            pid=fork();
            if(pid==0)
            {
                int content_length=0;
                while((size>0) && strcmp("\n",buf))//去除掉多余的请求头信息
                {
                    size=get_line(cli_fd,buf,sizeof(buf));
                    buf[15]='\0';
                    if(strcasecmp(buf,"Content-Length:")==0)
                    {
                        content_length=atoi(&(buf[16]));
                    }
                }
                if(content_length==0)
                {
                    Page_400(cli_fd);
                    return 0;
                }
                char c;
                j=0;
                for(int i=0;i<content_length;i++)
                {
                    recv(cli_fd,&c,1,0);
                    args[j]=c;
                    j++;
                }
                args[j]=0;
                ServerPostFunction(cli_fd,path,urldecode(args));
            }
        }
    }
    close(cli_fd);
    return 0;
}
int WebServer::ServerGetFunction(int cli_fd,char *path,char *args)
{
    ServerExecuteCGI(cli_fd,path,args);
    return 0;
}
int WebServer::ServerPostFunction(int cli_fd,char *path,char *args)
{
    ServerExecuteCGI(cli_fd,path,args);
    return 0;
}

int WebServer::ServerExecuteCGI(int cli_fd,char *path,char *args)
{
    char query_env[1024];
    char type[16]="text/html";
    pid_t pid;
    int status;
    int cgi_output[2];
    int cgi_input[2];

    if(pipe(cgi_output)<0)
    {
        Page_500(cli_fd);
        return 0;
    }
    if(pipe(cgi_input)<0)
    {
        Page_500(cli_fd);
        return 0;
    }

    if((pid=fork())<0)
    {
        Page_500(cli_fd);
        return 0;
    }
    if(pid==0)//child
    {
        dup2(cgi_output[1],1);//cgi的输出端绑定文件描述符为1的输出端
        dup2(cgi_input[0],0);
        close(cgi_output[0]);
        close(cgi_input[1]);
        sprintf(query_env,"QUERY_STRING=%s",args);
        putenv(query_env);
        execl(path,path,args);
        exit(0);
    }
    else //parent
    {
        char c;
        close(cgi_output[1]);//取消绑定
        close(cgi_input[0]);
        Page_Headers(cli_fd,type,0);
        while(read(cgi_output[0],&c,1)>0)
            send(cli_fd,&c,1,0);
        close(cgi_output[0]);
        close(cgi_input[1]);
    }
    waitpid(pid,&status,0);
    return 0;
}

int WebServer::ServerCatHttpPage(int cli_fd,char *path,int filesize)
{
    FILE * resource=NULL;
    int size=1;
    char buf[1024];
    char type[32];
    char * p =type;
    buf[0]=1;buf[1]=0;
    while((size>0) && strcmp("\n",buf))//去除掉多余的请求头信息
        size=get_line(cli_fd,buf,sizeof(buf));

    //判断文件类型
    get_filetype(type,path);
    cout<<"请求资源的类型:"<<type<<endl;

    resource=fopen(path,"r");//根据GET后面的文件吗，将文件打开
    if(resource==NULL)//打开文件失败
    {
        Page_404(cli_fd);
    }
    else
    {
        Page_Headers(cli_fd,p,filesize);
        Page_Cat(cli_fd,resource);
    }
    fclose(resource);
    return 0;
}

int WebServer::get_filetype(char *type,char *path)//用于判断该url指向文件的后缀
{
    if(strstr(path,".html"))
        strcpy(type,"text/html");
    else if(strstr(path,".gif"))
        strcpy(type,"image/gif");
    else if(strstr(path,".jpg"))
        strcpy(type,"image/jpeg");
    else if(strstr(path,".png"))
        strcpy(type,"image/png");
    else if(strstr(path,".ico"))
        strcpy(type,"image/x-icon");
    else if(strstr(path,".js"))
        strcpy(type,"text/javascript");
    else if(strstr(path,".json"))
        strcpy(type,"application/json");
    else if(strstr(path,".css"))
        strcpy(type,"text/css");
    else
        strcpy(type,"text/plain");
    return 0;
}

int WebServer::ServerAccept()
{
    struct sockaddr_in cli_sin;
    socklen_t cli_len=sizeof(cli_sin);
    int cli_fd;
    cli_fd=accept(httpd,(struct sockaddr *)&cli_sin,&cli_len);//阻塞等待连接
    if(cli_fd==-1)
        ServerError("Fail to accept");
    //cout<<"连接进来的IP: "<<inet_ntoa(cli_sin.sin_addr)<<":"<<ntohs(cli_sin.sin_port)<<endl;
    return cli_fd;
}
int WebServer::ServerInit(u_short port)
{
    struct sockaddr_in sin;
    int on;
    httpd=socket(PF_INET,SOCK_STREAM,0);
    if(httpd==-1)
        ServerError("Fail to Socket");
    //init sockaddr_in
    sin.sin_family=AF_INET;
    sin.sin_port=htons(port);
    sin.sin_addr.s_addr=htonl(INADDR_ANY);
    bzero(&(sin.sin_zero),8);
    setsockopt(httpd,SOL_SOCKET,SO_REUSEADDR,&on,sizeof(on));
    if(::bind(httpd,(struct sockaddr *)&sin,sizeof(struct sockaddr))==-1)
        ServerError("Fail to bind");
    //如果port指定为零那么就随机打开一个端口
    if(port==0)
    {
        socklen_t len=sizeof(sin);
        if(getsockname(httpd,(struct sockaddr *)&sin,&len)==-1)
            ServerError("Fail to getsockname");
        port=ntohs(sin.sin_port);
    }
    if(listen(httpd,100)<0)
        ServerError("Fail to listen");
    return port;
}
///////////////
int WebServer::get_line(int cli_fd,char * buf,int size)
{
    int i=0;
    char c='\0';
    int n;
    while((i<size-1)&&(c!='\n'))
    {
        n=recv(cli_fd,&c,1,0);
        if(n>0)
        {
            if(c=='\r')
            {
                n=recv(cli_fd,&c,1,MSG_PEEK);
                if((n>0)&&(c=='\n'))
                    recv(cli_fd,&c,1,0);
                else
                    c='\n';
            }
            buf[i]=c;
            i++;
        }
        else
            c='\n';
    }
    buf[i]='\0';
    return i;
}
int WebServer::ServerError(string str)
{
    perror(str.c_str());
    exit(-1);
}
int WebServer::ServerClose()
{
    close(httpd);
    return 0;
}
int WebServer::Page_Headers(int cli_fd,char * type,int filesize)
{
    char buf[1024];
    strcpy(buf,"HTTP/1.1 200 OK\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Server:wunaozai.cnblogs.com\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Content-Type: %s;charset=utf-8\r\n",type);
    send(cli_fd, buf, strlen(buf), 0);
    if(filesize>0)
    {
        sprintf(buf, "Content-Length: %d\r\n",filesize);
        send(cli_fd, buf, strlen(buf), 0);
    }
    sprintf(buf, "\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    return 0;
}
int WebServer::Page_Cat(int cli_fd,FILE * fp)
{
    char buf[1024];
    int c;

    while((c=fgetc(fp))!=EOF)
    {
        send(cli_fd,&c,1,0);
    }
    return 0;
}
int WebServer::Page_200(int cli_fd)
{
    char buf[1024];
    sprintf(buf, "HTTP/1.1 200 OK\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Server:wunaozai.cnblogs.com\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Content-Type: text/html\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<HTML><HEAD><TITLE>Hello World\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "</TITLE></HEAD>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<BODY><H1>Hello World</h1>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "</BODY></HTML>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
}
int WebServer::Page_400(int cli_fd)
{
    char buf[1024];
    sprintf(buf, "HTTP/1.1 400 BAD REQUEST\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Server:wunaozai.cnblogs.com\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Content-Type: text/html\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<p> your browser sent a bad request, such as a POST without a Conten-Length.\r\n");
    send(cli_fd, buf, strlen(buf), 0);
}
int WebServer::Page_404(int cli_fd)
{
    char buf[1024];
    sprintf(buf, "HTTP/1.1 404 NOT FOUND\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Server:wunaozai.cnblogs.com\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Content-Type: text/html;charset=utf-8\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<HTML><HEAD><TITLE>PAGE NOT FOUND\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "</TITLE></HEAD>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<BODY><H1>The server could not fulfill</h1>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<p>你请求的资源不在<p>");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "</BODY></HTML>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
}
int WebServer::Page_500(int cli_fd)
{
    char buf[1024];
    sprintf(buf, "HTTP/1.1 500 Internal Server Error\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Server:wunaozai.cnblogs.com");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Content-Type: text/html\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<p>Error prohibited CGI execution.\r\n");
    send(cli_fd, buf, strlen(buf), 0);
}
int WebServer::Page_501(int cli_fd)
{
    char buf[1024];
    sprintf(buf, "HTTP/1.1 501 Method Not Implemented\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Server:wunaozai.cnblogs.com");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "Content-Type: text/html\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<HTML><HEAD><TITLE>Method Not Implemented\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "</TITLE></HEAD>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "<BODY><P>HTTP request method not supported.\r\n");
    send(cli_fd, buf, strlen(buf), 0);
    sprintf(buf, "</BODY></HTML>\r\n");
    send(cli_fd, buf, strlen(buf), 0);
}
WebServer::~WebServer()
{
}
WebServer::WebServer()
{
}
